#ifndef _PICCODE_H_
#define _PICCODE_H_

#include "logger.h"

#define ADC_CH0                         0x00
#define ADC_CH1                         0x08
#define ADC_CH2                         0x10
#define ADC_CH3                         0x18
#define ADC_CH4                         0x20
#define ADC_CH5                         0x28
#define ADC_CH6                         0x30
#define ADC_CH7                         0x38


// firmware/software implementation of I2C
// SDA (data) and SCL (clock) bits
#define I2C_BUFFER_SIZE            0
#define I2C_ERROR                  0xFF
#define I2C_OUTPUT                 0
#define I2C_INPUT                  1

//#define   I2C_SCL                       porta&0x01
//#define   I2C_SDA                       porta&0x02

#define   I2C_SCL                       porta&0x08
#define   I2C_SDA                       porta&0x10


#define I2C_SCL_HIGH()             set_bit( porta, 3 ); \
                                        clear_bit( trisa, 3 )
#define I2C_SCL_LOW()              clear_bit( porta, 3 ); \
                                        clear_bit( trisa, 3 )
#define I2C_SDA_HIGH()             set_bit( porta, 4 ); \
                                        clear_bit( trisa, 4 )
#define I2C_SDA_LOW()              clear_bit( porta, 4 ); \
                                        clear_bit( trisa, 4 )

#define I2C_SCL_DIR_INPUT()        set_bit( trisa, 3 )
#define I2C_SCL_DIR_OUTPUT()  clear_bit( trisa, 3 )
#define I2C_SDA_DIR_INPUT()        set_bit( trisa, 4 )
#define I2C_SDA_DIR_OUTPUT()  clear_bit( trisa, 4 )

//# define I2C_DELAY_1uS()            delay_us( 16 )
//# define I2C_DELAY_4uS()            delay_us( 16 )
//# define I2C_DELAY_5uS()            delay_us( 16 )
//# define I2C_DELAY_10uS()      delay_us( 16 )

#define I2C_DELAY_1uS()            delay_ms( 1 )
#define I2C_DELAY_4uS()            delay_ms( 1 )
#define I2C_DELAY_5uS()            delay_ms( 1 )
#define I2C_DELAY_10uS()      delay_ms( 1 )

extern char i8_I2CData[I2C_BUFFER_SIZE];
extern char i2c_send_byte( char );
extern char i2c_read_byte( void );
extern char i2c_open( char );
extern void i2c_send_acknowledge( char more );
//extern void i2c_read_acknowledge(void);
extern void i2c_stop( void );
extern void txreg_putch( char c );
extern short timer1_clone;
extern char adc_continue( void );
extern void adc_init_channels( void );
extern short adc_read( char adc_ch );
extern void adc_start( char adc_ch );
extern short adc_get_adres( void );
extern char _EEPROMRead( char addr );
extern void EEPROMRead( char addr, char size );
extern void _EEPROMWrite( char addr, char data );
extern void EEPROMWrite( char addr, char size );
extern void sleep_mode( void );
extern void pwm1_dc_setup( short dc );
extern void pwm2_dc_setup( short dc );

#endif // _PICCODE_H_
